import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS CloudFront
*/
export interface DataAwsCloudfrontResponseHeadersPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_response_headers_policy#name DataAwsCloudfrontResponseHeadersPolicy#name}
    */
    readonly name?: string;
}
export declare class DataAwsCloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeaders extends cdktf.ComplexComputedList {
    get items(): string[];
}
export declare class DataAwsCloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethods extends cdktf.ComplexComputedList {
    get items(): string[];
}
export declare class DataAwsCloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOrigins extends cdktf.ComplexComputedList {
    get items(): string[];
}
export declare class DataAwsCloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeaders extends cdktf.ComplexComputedList {
    get items(): string[];
}
export declare class DataAwsCloudfrontResponseHeadersPolicyCorsConfig extends cdktf.ComplexComputedList {
    get accessControlAllowCredentials(): cdktf.IResolvable;
    get accessControlAllowHeaders(): cdktf.IResolvable;
    get accessControlAllowMethods(): cdktf.IResolvable;
    get accessControlAllowOrigins(): cdktf.IResolvable;
    get accessControlExposeHeaders(): cdktf.IResolvable;
    get accessControlMaxAgeSec(): number;
    get originOverride(): cdktf.IResolvable;
}
export declare class DataAwsCloudfrontResponseHeadersPolicyCustomHeadersConfigItems extends cdktf.ComplexComputedList {
    get header(): string;
    get override(): cdktf.IResolvable;
    get value(): string;
}
export declare class DataAwsCloudfrontResponseHeadersPolicyCustomHeadersConfig extends cdktf.ComplexComputedList {
    get items(): cdktf.IResolvable;
}
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicy extends cdktf.ComplexComputedList {
    get contentSecurityPolicy(): string;
    get override(): cdktf.IResolvable;
}
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptions extends cdktf.ComplexComputedList {
    get override(): cdktf.IResolvable;
}
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptions extends cdktf.ComplexComputedList {
    get frameOption(): string;
    get override(): cdktf.IResolvable;
}
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicy extends cdktf.ComplexComputedList {
    get override(): cdktf.IResolvable;
    get referrerPolicy(): string;
}
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurity extends cdktf.ComplexComputedList {
    get accessControlMaxAgeSec(): number;
    get includeSubdomains(): cdktf.IResolvable;
    get override(): cdktf.IResolvable;
    get preload(): cdktf.IResolvable;
}
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtection extends cdktf.ComplexComputedList {
    get modeBlock(): cdktf.IResolvable;
    get override(): cdktf.IResolvable;
    get protection(): cdktf.IResolvable;
    get reportUri(): string;
}
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfig extends cdktf.ComplexComputedList {
    get contentSecurityPolicy(): cdktf.IResolvable;
    get contentTypeOptions(): cdktf.IResolvable;
    get frameOptions(): cdktf.IResolvable;
    get referrerPolicy(): cdktf.IResolvable;
    get strictTransportSecurity(): cdktf.IResolvable;
    get xssProtection(): cdktf.IResolvable;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_response_headers_policy aws_cloudfront_response_headers_policy}
*/
export declare class DataAwsCloudfrontResponseHeadersPolicy extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_response_headers_policy aws_cloudfront_response_headers_policy} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAwsCloudfrontResponseHeadersPolicyConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAwsCloudfrontResponseHeadersPolicyConfig);
    get comment(): string;
    corsConfig(index: string): DataAwsCloudfrontResponseHeadersPolicyCorsConfig;
    customHeadersConfig(index: string): DataAwsCloudfrontResponseHeadersPolicyCustomHeadersConfig;
    get etag(): string;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    securityHeadersConfig(index: string): DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfig;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
