import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Connect
*/
export interface DataAwsConnectHoursOfOperationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_hours_of_operation#hours_of_operation_id DataAwsConnectHoursOfOperation#hours_of_operation_id}
    */
    readonly hoursOfOperationId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_hours_of_operation#instance_id DataAwsConnectHoursOfOperation#instance_id}
    */
    readonly instanceId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_hours_of_operation#name DataAwsConnectHoursOfOperation#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_hours_of_operation#tags DataAwsConnectHoursOfOperation#tags}
    */
    readonly tags?: {
        [key: string]: string;
    };
}
export declare class DataAwsConnectHoursOfOperationConfigEndTime extends cdktf.ComplexComputedList {
    get hours(): number;
    get minutes(): number;
}
export declare class DataAwsConnectHoursOfOperationConfigStartTime extends cdktf.ComplexComputedList {
    get hours(): number;
    get minutes(): number;
}
export declare class DataAwsConnectHoursOfOperationConfigA extends cdktf.ComplexComputedList {
    get day(): string;
    get endTime(): cdktf.IResolvable;
    get startTime(): cdktf.IResolvable;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/aws/d/connect_hours_of_operation aws_connect_hours_of_operation}
*/
export declare class DataAwsConnectHoursOfOperation extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/aws/d/connect_hours_of_operation aws_connect_hours_of_operation} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAwsConnectHoursOfOperationConfig
    */
    constructor(scope: Construct, id: string, config: DataAwsConnectHoursOfOperationConfig);
    config(index: string): DataAwsConnectHoursOfOperationConfigA;
    get description(): string;
    get hoursOfOperationArn(): string;
    private _hoursOfOperationId?;
    get hoursOfOperationId(): string;
    set hoursOfOperationId(value: string);
    resetHoursOfOperationId(): void;
    get hoursOfOperationIdInput(): string | undefined;
    get id(): string;
    private _instanceId?;
    get instanceId(): string;
    set instanceId(value: string);
    get instanceIdInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _tags?;
    get tags(): {
        [key: string]: string;
    };
    set tags(value: {
        [key: string]: string;
    });
    resetTags(): void;
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    get timeZone(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
