import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Connect
*/
export interface DataAwsConnectQuickConnectConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_quick_connect#instance_id DataAwsConnectQuickConnect#instance_id}
    */
    readonly instanceId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_quick_connect#name DataAwsConnectQuickConnect#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_quick_connect#quick_connect_id DataAwsConnectQuickConnect#quick_connect_id}
    */
    readonly quickConnectId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_quick_connect#tags DataAwsConnectQuickConnect#tags}
    */
    readonly tags?: {
        [key: string]: string;
    };
}
export declare class DataAwsConnectQuickConnectQuickConnectConfigPhoneConfig extends cdktf.ComplexComputedList {
    get phoneNumber(): string;
}
export declare class DataAwsConnectQuickConnectQuickConnectConfigQueueConfig extends cdktf.ComplexComputedList {
    get contactFlowId(): string;
    get queueId(): string;
}
export declare class DataAwsConnectQuickConnectQuickConnectConfigUserConfig extends cdktf.ComplexComputedList {
    get contactFlowId(): string;
    get userId(): string;
}
export declare class DataAwsConnectQuickConnectQuickConnectConfig extends cdktf.ComplexComputedList {
    get phoneConfig(): cdktf.IResolvable;
    get queueConfig(): cdktf.IResolvable;
    get quickConnectType(): string;
    get userConfig(): cdktf.IResolvable;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/aws/d/connect_quick_connect aws_connect_quick_connect}
*/
export declare class DataAwsConnectQuickConnect extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/aws/d/connect_quick_connect aws_connect_quick_connect} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAwsConnectQuickConnectConfig
    */
    constructor(scope: Construct, id: string, config: DataAwsConnectQuickConnectConfig);
    get arn(): string;
    get description(): string;
    get id(): string;
    private _instanceId?;
    get instanceId(): string;
    set instanceId(value: string);
    get instanceIdInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    quickConnectConfig(index: string): DataAwsConnectQuickConnectQuickConnectConfig;
    private _quickConnectId?;
    get quickConnectId(): string;
    set quickConnectId(value: string);
    resetQuickConnectId(): void;
    get quickConnectIdInput(): string | undefined;
    private _tags?;
    get tags(): {
        [key: string]: string;
    };
    set tags(value: {
        [key: string]: string;
    });
    resetTags(): void;
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
