import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS EC2
*/
export interface DataAwsLaunchTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/launch_template#name DataAwsLaunchTemplate#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/launch_template#tags DataAwsLaunchTemplate#tags}
    */
    readonly tags?: {
        [key: string]: string;
    };
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/launch_template#filter DataAwsLaunchTemplate#filter}
    */
    readonly filter?: DataAwsLaunchTemplateFilter[] | cdktf.IResolvable;
}
export declare class DataAwsLaunchTemplateBlockDeviceMappingsEbs extends cdktf.ComplexComputedList {
    get deleteOnTermination(): string;
    get encrypted(): string;
    get iops(): number;
    get kmsKeyId(): string;
    get snapshotId(): string;
    get throughput(): number;
    get volumeSize(): number;
    get volumeType(): string;
}
export declare class DataAwsLaunchTemplateBlockDeviceMappings extends cdktf.ComplexComputedList {
    get deviceName(): string;
    get ebs(): cdktf.IResolvable;
    get noDevice(): string;
    get virtualName(): string;
}
export declare class DataAwsLaunchTemplateCreditSpecification extends cdktf.ComplexComputedList {
    get cpuCredits(): string;
}
export declare class DataAwsLaunchTemplateElasticGpuSpecifications extends cdktf.ComplexComputedList {
    get type(): string;
}
export declare class DataAwsLaunchTemplateEnclaveOptions extends cdktf.ComplexComputedList {
    get enabled(): cdktf.IResolvable;
}
export declare class DataAwsLaunchTemplateHibernationOptions extends cdktf.ComplexComputedList {
    get configured(): cdktf.IResolvable;
}
export declare class DataAwsLaunchTemplateIamInstanceProfile extends cdktf.ComplexComputedList {
    get arn(): string;
    get name(): string;
}
export declare class DataAwsLaunchTemplateInstanceMarketOptionsSpotOptions extends cdktf.ComplexComputedList {
    get blockDurationMinutes(): number;
    get instanceInterruptionBehavior(): string;
    get maxPrice(): string;
    get spotInstanceType(): string;
    get validUntil(): string;
}
export declare class DataAwsLaunchTemplateInstanceMarketOptions extends cdktf.ComplexComputedList {
    get marketType(): string;
    get spotOptions(): cdktf.IResolvable;
}
export declare class DataAwsLaunchTemplateMetadataOptions extends cdktf.ComplexComputedList {
    get httpEndpoint(): string;
    get httpProtocolIpv6(): string;
    get httpPutResponseHopLimit(): number;
    get httpTokens(): string;
    get instanceMetadataTags(): string;
}
export declare class DataAwsLaunchTemplateMonitoring extends cdktf.ComplexComputedList {
    get enabled(): cdktf.IResolvable;
}
export declare class DataAwsLaunchTemplateNetworkInterfaces extends cdktf.ComplexComputedList {
    get associateCarrierIpAddress(): string;
    get associatePublicIpAddress(): string;
    get deleteOnTermination(): string;
    get description(): string;
    get deviceIndex(): number;
    get interfaceType(): string;
    get ipv4AddressCount(): number;
    get ipv4Addresses(): string[];
    get ipv6AddressCount(): number;
    get ipv6Addresses(): string[];
    get networkCardIndex(): number;
    get networkInterfaceId(): string;
    get privateIpAddress(): string;
    get securityGroups(): string[];
    get subnetId(): string;
}
export declare class DataAwsLaunchTemplatePlacement extends cdktf.ComplexComputedList {
    get affinity(): string;
    get availabilityZone(): string;
    get groupName(): string;
    get hostId(): string;
    get hostResourceGroupArn(): string;
    get partitionNumber(): number;
    get spreadDomain(): string;
    get tenancy(): string;
}
export declare class DataAwsLaunchTemplateTagSpecifications extends cdktf.ComplexComputedList {
    get resourceType(): string;
    get tags(): {
        [key: string]: string;
    };
}
export interface DataAwsLaunchTemplateFilter {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/launch_template#name DataAwsLaunchTemplate#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/launch_template#values DataAwsLaunchTemplate#values}
    */
    readonly values: string[];
}
export declare function dataAwsLaunchTemplateFilterToTerraform(struct?: DataAwsLaunchTemplateFilter | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/aws/d/launch_template aws_launch_template}
*/
export declare class DataAwsLaunchTemplate extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/aws/d/launch_template aws_launch_template} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAwsLaunchTemplateConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAwsLaunchTemplateConfig);
    get arn(): string;
    blockDeviceMappings(index: string): DataAwsLaunchTemplateBlockDeviceMappings;
    creditSpecification(index: string): DataAwsLaunchTemplateCreditSpecification;
    get defaultVersion(): number;
    get description(): string;
    get disableApiTermination(): cdktf.IResolvable;
    get ebsOptimized(): string;
    elasticGpuSpecifications(index: string): DataAwsLaunchTemplateElasticGpuSpecifications;
    enclaveOptions(index: string): DataAwsLaunchTemplateEnclaveOptions;
    hibernationOptions(index: string): DataAwsLaunchTemplateHibernationOptions;
    iamInstanceProfile(index: string): DataAwsLaunchTemplateIamInstanceProfile;
    get id(): string;
    get imageId(): string;
    get instanceInitiatedShutdownBehavior(): string;
    instanceMarketOptions(index: string): DataAwsLaunchTemplateInstanceMarketOptions;
    get instanceType(): string;
    get kernelId(): string;
    get keyName(): string;
    get latestVersion(): number;
    metadataOptions(index: string): DataAwsLaunchTemplateMetadataOptions;
    monitoring(index: string): DataAwsLaunchTemplateMonitoring;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    networkInterfaces(index: string): DataAwsLaunchTemplateNetworkInterfaces;
    placement(index: string): DataAwsLaunchTemplatePlacement;
    get ramDiskId(): string;
    get securityGroupNames(): string[];
    tagSpecifications(index: string): DataAwsLaunchTemplateTagSpecifications;
    private _tags?;
    get tags(): {
        [key: string]: string;
    };
    set tags(value: {
        [key: string]: string;
    });
    resetTags(): void;
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    get userData(): string;
    get vpcSecurityGroupIds(): string[];
    private _filter?;
    get filter(): DataAwsLaunchTemplateFilter[] | cdktf.IResolvable;
    set filter(value: DataAwsLaunchTemplateFilter[] | cdktf.IResolvable);
    resetFilter(): void;
    get filterInput(): cdktf.IResolvable | DataAwsLaunchTemplateFilter[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
