import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
* AWS Elastic Kubernetes Service
*/
export interface DataAwsEksClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/eks_cluster#name DataAwsEksCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/eks_cluster#tags DataAwsEksCluster#tags}
    */
    readonly tags?: {
        [key: string]: string;
    };
}
export declare class DataAwsEksClusterCertificateAuthority extends cdktf.ComplexComputedList {
    get data(): string;
}
export declare class DataAwsEksClusterIdentityOidc extends cdktf.ComplexComputedList {
    get issuer(): string;
}
export declare class DataAwsEksClusterIdentity extends cdktf.ComplexComputedList {
    get oidc(): cdktf.IResolvable;
}
export declare class DataAwsEksClusterKubernetesNetworkConfig extends cdktf.ComplexComputedList {
    get ipFamily(): string;
    get serviceIpv4Cidr(): string;
}
export declare class DataAwsEksClusterVpcConfig extends cdktf.ComplexComputedList {
    get clusterSecurityGroupId(): string;
    get endpointPrivateAccess(): cdktf.IResolvable;
    get endpointPublicAccess(): cdktf.IResolvable;
    get publicAccessCidrs(): string[];
    get securityGroupIds(): string[];
    get subnetIds(): string[];
    get vpcId(): string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/aws/d/eks_cluster aws_eks_cluster}
*/
export declare class DataAwsEksCluster extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/aws/d/eks_cluster aws_eks_cluster} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAwsEksClusterConfig
    */
    constructor(scope: Construct, id: string, config: DataAwsEksClusterConfig);
    get arn(): string;
    certificateAuthority(index: string): DataAwsEksClusterCertificateAuthority;
    get createdAt(): string;
    get enabledClusterLogTypes(): string[];
    get endpoint(): string;
    get id(): string;
    identity(index: string): DataAwsEksClusterIdentity;
    kubernetesNetworkConfig(index: string): DataAwsEksClusterKubernetesNetworkConfig;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get platformVersion(): string;
    get roleArn(): string;
    get status(): string;
    private _tags?;
    get tags(): {
        [key: string]: string;
    };
    set tags(value: {
        [key: string]: string;
    });
    resetTags(): void;
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    get version(): string;
    vpcConfig(index: string): DataAwsEksClusterVpcConfig;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
